<?php
$isMaster = $this->environment()->getClient()->isMaster();
$bar      = $this->module()->getClientModuleConfiguration('indicator', 'analysis_measures_bar');
?>
<div ng-controller="recapWithMeasuresController as self"
     ng-init="self.initQueries()">
    <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
        <div class="row">
            <div class="col-md-4 col-md-offset-8">
                <div class="queries-toggler little-panel">
                    <div href="#queries-collapsed-node-tree-recap-with-measures"
                         data-toggle="collapse"
                         class="title">
                        <i class="fa fa-shopping-basket fa-fw"></i>
                        Requêtes
                    </div>

                    <div id="queries-collapsed-node-tree-recap-with-measures"
                         class="body collapse">
                        <div ng-if="self.loadingQueries"
                             class="text-center">
                            <i class="fa fa-spin fa-circle-o-notch"></i>
                        </div>

                        <ul class="list-unstyled">
                            <li ng-repeat="query in self.queries">
                                <a ng-click="self.loadQuery(query)"
                                   class="pointer">
                                    <i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
                                </a>

                                <i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
                                   tooltip="Supprimer"
                                   class="fa fa-trash pointer pull-right">
                                </i>
                            </li>
                        </ul>

                        <form ng-submit="self.saveQuery()"
                              name="queryForm">
                            <div class="input-group input-group-sm">
                                <input ng-model="self.query.name"
                                       placeholder="Nom de la requête"
                                       type="text"
                                       class="form-control"
                                       required/>

                                <span class="input-group-btn">
                                    <?php if (!$this->acl()->onlyOwned('application:e:query:r') && !$this->acl()->onlyOwned('application:e:query:u')) : ?>
                                        <label class="checkbox-inline" style="margin: 0 10px">
                                            <input type="checkbox" ng-model="self.query.shared"/>
                                            Partagée ?
                                        </label>
                                    <?php endif; ?>
                                    <button ng-disabled="self.loadingSaveQuery"
                                            type="submit"
                                            class="btn btn-submit">
                                        <i ng-if="self.loadingSaveQuery"
                                           class="fa fa-spin fa-circle-o-notch">
                                        </i>
                                        Enregistrer
                                    </button>
                                </span>
                            </div>

                            <field-errors field="name"
                                          errors="errors.fields">
                            </field-errors>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    <?php endif ?>
    <div class="row separator">
        <div ng-controller="filterController as filter"
             ng-init="filter.init('indicator')"
             class="col-md-4">
            <div class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-with-measures-indicator">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('indicator_entity')) ?>
                </div>
                <div id="filters-collapsed-recap-with-measures-indicator" class="body collapse">
                    <?= $this->tableFilter('self.filters.indicator', $this->indicatorFilters()); ?>
                </div>
            </div>
        </div>
        <?php if ($this->module()->isActive('project')) : ?>
            <div ng-controller="projectFilterController as filter"
                 ng-init="filter.init('project', null, <?= $isMaster ? 'false' : 'true' ?>)"
                 class="col-md-4">
                <div class="table-filters little-panel">
                    <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-with-measures-project">
                        <?= $this->icon('filters', 'fa-fw') ?>
                        <?= $this->translate('filters') ?>
                        <?= ucfirst($this->translate('project_entity')) ?>
                    </div>
                    <div id="filters-collapsed-recap-with-measures-project" class="body collapse project">
                        <?= $this->tableFilter('self.filters.project', $this->projectFilters($isMaster ? ['external', 'ownership', 'networkAccessible', 'managers', 'validators', 'members', 'actors', 'ownership', 'parent', 'financer', 'level', 'budgetStatus'] : [])); ?>
                    </div>
                </div>
            </div>
        <?php endif; ?>
        <div ng-controller="measureController as filter"
             ng-init="filter.init('measure')"
             class="col-md-4">
            <div class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-with-measures-measure">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('measure_entity')) ?>
                </div>
                <div id="filters-collapsed-recap-with-measures-measure" class="body collapse">
                    <?= $this->tableFilter('self.filters.measure', $this->measureFilters($isMaster ? ['indicator', 'project'] : ['indicator', 'project', 'client'])); ?>
                </div>
            </div>
        </div>
        <div class="row separator">
            <div class="col-md-4 col-md-offset-4">
                <div class="row">
                    <div class="col-xs-6">
                        <button class="btn" ng-click="self.resetFilters()">
                            <?= $this->translate('table_filter_reset_button') ?>
                        </button>
                    </div>
                    <div class="col-xs-6 text-right">
                        <button class="btn" ng-click="self.applyFilters()">
                            <?= $this->icon('search', 'fa-fw') ?>
                            <?= $this->translate('table_filter_button') ?>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator" ng-if="self.loading">
        <div class="col-xs-12 text-center">
            <?= $this->icon('loading') ?>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-12">
            <div class="btn-group pull-right">
                <button class="btn btn-excel"
                        type="button"
                        ng-click="self.export()"
                        tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                    <?= $this->icon('excel', 'fa-fw pointer') ?>
                </button>
            </div>
            <?php if ($bar) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'bar'">
                        <i class="fa fa-bar-chart"></i>
                    </button>
                </div>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'table'">
                        <i class="fa fa-table"></i>
                    </button>
                </div>
            <?php endif; ?>
            <br />
            <br />
        </div>
    </div>
    <div class="row">
        <div class="col-sm-12">
            <div class="pull-left">
                <?= $this->translate('number_filters') ?>
            </div>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'bar'">
        <div class="col-xs-12" ng-repeat="bar in self.chart.bar">
            <h3>{{bar.name}}</h3>
            <nvd3 options="bar.options" data="bar.data" api="bar.api"></nvd3>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'table'">
        <div class="col-xs-12">
            <div class="table-scroller">
                <table class="table table-bordered table-condensed table-hover">
                    <thead>
                    <tr>                        
                        <th><?= $this->translate('measure_field_client') ?></th>
                        <th><?= $this->translate('measure_field_type') ?></th>
                        <th><?= $this->translate('measure_field_start') ?></th>
                        <th><?= $this->translate('measure_field_date') ?></th>
                        <th><?= $this->translate('measure_field_value') ?></th>
                        <?php if ($this->module()->isActive('project')) : ?>
                            <th><?= $this->translate('measure_field_project') ?></th>
                        <?php endif; ?>
                        <?php if ($this->module()->isActive('map')) : ?>
                            <th><?= $this->translate('measure_field_territories') ?></th>
                        <?php endif; ?>
                        <th><?= $this->translate('measure_field_comment') ?></th>
                        <th><?= $this->translate('measure_field_source') ?></th>
                        <th><?= $this->translate('indicator_field_description') ?></th>
                    </tr>
                    </thead>
                    <tbody ng-repeat="(indicator, measures) in self.measures | groupBy : 'indicator.name'">
                    <tr class="group">
                        <td colspan="11" class="pointer" ng-click="showMeasures = !showMeasures">
                            <i class="fa fa-caret-right" ng-class="{'fa-caret-right' : !showMeasures, 'fa-caret-down' : showMeasures}"></i>
                            {{ indicator }} <i>{{ measures[0].indicator.uom ? '(' + measures[0].indicator.uom + ')' : '' }}</i>
                        </td>
                    </tr>
                    <tr ng-repeat="measure in measures" ng-show="showMeasures" ng-class="{editing: self.editedLine == measure}">
                        <td>{{ measure.client.name }}</td>
                        <td>{{ 'measure_type_' + measure.type | translate }}</td>
                        <td>{{ measure.start | dateFormat : 'DD/MM/YYYY' }}</td>
                        <td>{{ measure.date | dateFormat : 'DD/MM/YYYY' }}</td>
                        <td class="text-right" ng-style="{background: measure.fixedValue.color}">{{ measure.fixedValue.text }}</td>
                        <?php if ($this->module()->isActive('project')) : ?>
                            <td>
                                <?php if ($this->acl()->isAllowed('project:e:project:r')) : ?>
                                    <a href="<?= $this->url('project/form') ?>/{{measure.project.id}}">{{measure.project.name}}</a>
                                <?php else : ?>
                                    {{ measure.project.name }}
                                <?php endif; ?>
                            </td>
                        <?php endif; ?>
                        <?php if ($this->module()->isActive('map')) : ?>
                            <td>
                                <span class="comma-separated">
                                    <span ng-repeat="territory in measure.territories"><!--
                                        -->{{territory.name}}<!--
                                    --></span>
                                </span>
                            </td>
                        <?php endif; ?>
                        <td>{{ measure.comment }}</td>
                        <td>{{ measure.source }}</td>
                        <td>{{ measure.indicator.description }}</td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
